#include <string.h>
#include "DAGH.h"
#include "Consts.h"
#include "ADMvar.h"
#include "SArray.h"
#include "TArray.h"
#include "BHmask.h"
#include "Variables.h"
#include "tstep.h"
#include "input_params.h"

#define f_plot1 FORTRAN_NAME(f_plot1_,F_PLOT1,f_plot1)
extern "C" void  f_plot1(BI, double *, char *, double *, int *, int *, 
                        int *, int *, double *, double *);

#define f_plot2 FORTRAN_NAME(f_plot2_,F_PLOT2,f_plot2)
extern "C" void  f_plot2(BI, double *, char *, double *, int *, int *, 
                        double *, double *);

void DataOut0(V &VA, double time, double Delta_t, int t,
      int Level, int IDENT, int myrank) {
      ADMstensor *g=VA.g;
      ADMstensor *k=VA.k;
      ADMscalar *alpha=VA.alpha;
      ADMvector *beta=VA.beta;
      BHmask *theMask=VA.theMask;
      SArray *shift_p=VA.shift_p;
      SArray *shift_po=VA.shift_po;
      TArray *shift_t=VA.shift_t;
      ADMtemp *tmp_pool=VA.tmp_pool;
      double *params=VA.params;
 
      char name1[40], name2[40], name3[40], name4[40], name5[40];
      char name6[40], name7[40], name8[40], name9[40], name10[40];
      DOUBLE subval0,subval1;
      INTEGER dir1,dir2,dir3,val1,val2,val3;     

      INTEGER cg;
      GridFunction(DIM)<DOUBLE> &st = *(*g).spacetime[0];

      val1=(params[P_NX]+1)/2;
      val2=(params[P_NY]+1)/2;
      val3=(params[P_NZ]+1)/2;
      dir1=2;
      dir2=3;
      dir3=1;
      strcpy(name1,"gxx-1");
      strcpy(name2,"gyy-1");
      strcpy(name3,"gzz-1");
      strcpy(name4,"gxy");
      strcpy(name5,"gxz");
      strcpy(name6,"kxx");
      strcpy(name7,"kyy");
      strcpy(name8,"kzz");
      strcpy(name9,"kxy");
      strcpy(name10,"kxz");
      subval0=0;
      subval1=1.0;

      forall(st,t,Level,cg){

       f_plot1(FBA(st(t,Level,cg,DAGH_Main)),
         (*(*g).spacetime[0])(t,Level,cg,DAGH_Main).data(),
         name1,&time,&dir1,&dir2,&val1,&val2,&subval1,params);       

       f_plot1(FBA(st(t,Level,cg,DAGH_Main)),
         (*(*g).spacetime[3])(t,Level,cg,DAGH_Main).data(),
         name2,&time,&dir1,&dir2,&val1,&val2,&subval1,params);       

       f_plot1(FBA(st(t,Level,cg,DAGH_Main)),
         (*(*k).spacetime[0])(t,Level,cg,DAGH_Main).data(),
         name6,&time,&dir1,&dir2,&val1,&val2,&subval0,params);

/*
       f_plot1(FBA(st(t,Level,cg,DAGH_Main)),
         (*(*g).spacetime[5])(t,Level,cg,DAGH_Main).data(),
         name3,&time,&dir1,&dir2,&val1,&val2,&subval1,params);       


       f_plot1(FBA(st(t,Level,cg,DAGH_Main)),
         (*(*g).spacetime[1])(t,Level,cg,DAGH_Main).data(),
         name4,&time,&dir1,&dir2,&val1,&val2,&subval0,params);       

       f_plot1(FBA(st(t,Level,cg,DAGH_Main)),
         (*(*g).spacetime[2])(t,Level,cg,DAGH_Main).data(),
         name5,&time,&dir1,&dir2,&val1,&val2,&subval0,params);       
       f_plot1(FBA(st(t,Level,cg,DAGH_Main)),
         (*(*k).spacetime[3])(t,Level,cg,DAGH_Main).data(),
         name7,&time,&dir1,&dir2,&val1,&val2,&subval0,params);       

       f_plot1(FBA(st(t,Level,cg,DAGH_Main)),
         (*(*k).spacetime[5])(t,Level,cg,DAGH_Main).data(),
         name8,&time,&dir1,&dir2,&val1,&val2,&subval0,params);       

       f_plot1(FBA(st(t,Level,cg,DAGH_Main)),
         (*(*k).spacetime[1])(t,Level,cg,DAGH_Main).data(),
         name9,&time,&dir1,&dir2,&val1,&val2,&subval0,params);       

       f_plot1(FBA(st(t,Level,cg,DAGH_Main)),
         (*(*k).spacetime[2])(t,Level,cg,DAGH_Main).data(),
         name10,&time,&dir1,&dir2,&val1,&val2,&subval0,params);       

       f_plot2(FBA(st(t,Level,cg,DAGH_Main)),
         (*(*g).spacetime[0])(t,Level,cg,DAGH_Main).data(), 
         name1,&time,&dir3,&val3,&subval0,params);       

*/

       } end_forall;


  }

